
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>日志系统之基于Zookeeper的分布式协同设计 / iVAN</title>

    <meta name="description" content="日志系统之基于Zookeeper的分布式协同设计 最近这段时间在设计和实现日志系统,在整个日志系统系统中Zookeeper的作用非常重要--它用于协调各个分布式组件并提供必要的配置信息和元数据.这篇文章主要分享一下Zookeeper的使用场景.这里主要涉及到Zookeeper在日志系统中的使用,但其实它在我们的消息总线和搜索模块中也同样非常重要. 日志元数据 日志的类型和日志的字段这里我们统称为日志的元数据.我们构建日志系统的目的最终主要是为了:日志搜索,日志分析.这两大块我们很大程度上依赖于--ElasticSearch(关于什么是Elast">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">日志系统之基于Zookeeper的分布式协同设计</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>最近这段时间在设计和实现日志系统，在整个日志系统系统中Zookeeper的作用非常重要——它用于协调各个分布式组件并提供必要的配置信息和元数据。这篇文章主要分享一下Zookeeper的使用场景。这里主要涉及到Zookeeper在日志系统中的使用，但其实它在我们的消息总线和搜索模块中也同样非常重要。</p>
<h2>日志元数据</h2>
<p>日志的类型和日志的字段这里我们统称为日志的元数据。我们构建日志系统的目的最终主要是为了：日志搜索，日志分析。这两大块我们很大程度上依赖于——ElasticSearch（关于什么是ElasticSearch，这里就不多做介绍了）。</p>
<h3>关于日志字段</h3>
<p>日志的字段定义，在ElasticSearch中是一个索引中某个mapping的Schema。ElasticSearch是一个号称<code>Schema<br />
Free</code>的分布式全文检索系统。这里需要正确地理解<code>Schema<br />
Free</code>，它并不是不需要Schema，也不是强制要求你必须有明确的Schema，有没有都可以做全文检索。但是像聚合、分析等很多高级功能都建立在明确的Schema的基础上。因此，从分析统计的角度看，我们对日志进行明确的字段定义是很有必要的。</p>
<h3>日志与搜索模块的协同</h3>
<p>日志元数据是日志系统的基础信息，我们在web管控台管理它并同步至Zookeeper供其他模块使用，比如搜索模块。因为上文提到日志的类型、字段其实跟ElasticSearch的<code>Mapping<br />
Type</code>是对等的映射关系，所以搜索模块会重度依赖日志元数据。另外，为了保证新的日志元数据（通常是一个新的日志类型被创建）尽快同步至ElasticSearch，我们利用了Zookeeper的事件Push机制（或者叫Pub/Sub机制）来实时获知日志元数据的变化。一旦有新的日志元数据产生，我们的搜索模块会立即得到事件通知，它会获取最新的日志元数据，然后为其在ElasticSearch的indices中新建一个mapping，为这种日志类型的日志存入ElasticSearch做好准备。</p>
<p>这种方式带来了哪些好处，目前来看至少有三点：</p>
<ul>
<li>实时性：搜索模块能第一时间感知到新的日志类型的创建</li>
<li>低耦合性：管控台上日志模块跟搜索模块，没有因为信息的依赖而产生较强的耦合性；它们通过Zookeeper进行了解耦</li>
<li>Mapping Type的可控性：ElasticSearch有个非常好的特性，就是当你将一个文档存入某个mapping<br />
type，如果该文档中存在mapping未曾定义的字段，ElasticSearch将会为你自动添加该字段的定义。我们认为这种机制将会使日志字段变得不可控。因此我们通过统一日志元数据再加上后面基于同样的解析行为来保证Schema的可控性。</li>
</ul>
<h2>日志采集</h2>
<p>从之前的文章中，你应该可以找到日志采集器的选型，出于多种原因（跟<a href="https://github.com/yanghua/banyan" rel="external nofollow noreferrer">消息总线</a>的集成、可定制性、支持从zookeeper获取配置等），我们选择了Flume-ng。它在最新的稳定版（1.6.0）提供了从zookeeper获取采集配置的功能。于是，日志采集花费在运维上的成本就大大降低了。因为有了配置之后，运维人员就不需要手动在目标服务器上修改配置文件，完成各种配置，只需要固定键入如下的启动命令即可：</p>
<pre><code>sudo bin/flume-ng agent --conf conf -z 127.0.0.1:2181 -p /component/log/mysqlSlowquery/flume -name mysql-slowquery-30 -Dflume.root.logger=DEBUG,console</code></pre>
<p>而上面这个命令中，唯一需要变动的只有以下几个部分：</p>
<ul>
<li>zookeeper的服务器（集群）信息</li>
<li>即将收集的日志的类型的flume路径</li>
<li>即将收集的日志的flume配置的znode名称，如上例是<code>mysql-slowquery-30</code></li>
</ul>
<p>其实原先需要手动修改配置文件的部分参数项将在提供的管控台中进行配置，但基于web的表单填写显然要比在服务器上以命令行的方式来得容易得多。</p>
<p>这里我们的做法是拆解了flume的配置文件，将其固定不变的部分做成模板，将其可变部分做成表单。在提交之前，通过模板引擎将模板跟配置信息进行合并为完整的配置并推送到Zookeeper中去。</p>
<p>其中需要配置的部分参数有：</p>
<ul>
<li>日志文件所在目标服务器的路径位置</li>
<li>日志文件名称的格式</li>
<li>日志是单行模式还是多行模式</li>
<li>消息源的secret(消息总线部分)</li>
<li>消息槽的名称（消息总线部分）</li>
<li>消息流的token（消息总线部分）</li>
<li>….</li>
</ul>
<h2>日志解析</h2>
<p>同样在之前的文章中我也提及我们在日志解析上的选择是morphline。morphline是个在Hadoop生态系统中的ETL<br />
Framework。morphline也有一个配置文件用于定义一系列的Commands。而它也有固定部分和可变部分，因为解析主要应用了morphline的<code>Grok</code>命令，所以针对这个命令，可变部分主要是：</p>
<ul>
<li>解析字典</li>
<li>解析的正则表达式</li>
</ul>
<p>我们的做法同样类似于日志采集模块，将morphline的配置文件的固定部分做成固定模板，然后将可变部分在管控台上进行配置，最终合并提交到Zookeeper中。</p>
<p>日志解析服务（归属于下面的<code>后台服务</code>），在启动时会根据自己的日志类型，从Zookeeper的特定节点下找到该日志类型的morphline的配置，将其获取下来并保存在本地文件系统中，然后构建Mrophline对象（因为morphline目前只提供基于File对象的构造方式，所以多了一个先保存至本地文件再基于文件构造Morphline对象的步骤）进行解析。</p>
<h2>后台服务</h2>
<p>日志解析这边只是给解析任务提供了 <strong><em>元数据</em></strong><br />
，真正的解析由后台的解析任务来完成，我们将类似的这些允许在后台的所有任务笼统得归结为 <strong>后台服务</strong> 。</p>
<p>后台服务遵循：<code>任务组</code>-&gt;<code>任务</code>-&gt;<code>工作线程</code>的层次性的组织方式。按照服务的业务类型（说白了就是同一套处理逻辑），将其划分为不同的任务组（比如：ETL组、日志索引组等），不同的任务组下会有<br />
<strong>至少</strong><br />
一个任务，比如ETL任务组下就会有很多个任务（比如：nginx访问日志解析任务、mysql慢查询日志解析任务等），而某一个任务下又存在至少一个工作线程。</p>
<h3>任务元数据</h3>
<p>在管控台有一个后台服务模块，专门用于管理任务对象以及它们的元数据。</p>
<p>执行任务的工作者线程本身是无状态的，它们在启动的时候会去Zookeeper上下载它们执行任务所需要的元数据。</p>
<h3>热备机制</h3>
<p>通常，为了服务的可用性我们会为每个任务配备不少于一个工作者线程。当然，这里的 <strong>不少于一个</strong><br />
并不只是基于一个运行后台服务的JVM进程或一个主机节点来计数的，而是针对由多个节点组成的集群而言。</p>
<p>这通过一个配置来实现：</p>
<pre><code>worker.minimumNumPerTask=2</code></pre>
<p>它的意义是：对每个task而言，启动的最少的worker线程数。如果一个主机节点上启动两个后台服务的JVM进程，那么这个task就会对应4个工作者线程。</p>
<p>正常情况下，每个任务在同一时刻只有一个处于active状态的工作者线程，而其他抢占失败的都会将自己切换为standby模式，作为备援随时待命。</p>
<p>这个机制是如何实现的？这得益于Zookeeper提供的 <strong>临时顺序</strong> 节点。</p>
<p>当多个工作者线程去竞争一个任务的时候，它们首先去该任务的path下创建一个子path，并注册自己的主机等信息。注意这里创建的子path的类型不同于其他Zookeeper使用场景的path类型（其他path通常都是持久型的），它是<strong>临时</strong>、<strong>顺序</strong>的。这两个属性非常重要：</p>
<ul>
<li>临时： 当一个工作者线程挂掉之后，它本地的Zookeeper会话也会随之失效，在其会话失效之后，临时节点将会消失。</li>
<li>顺序：它能仲裁出创建path的客户端的先后顺序，并在新建的path中追加标识</li>
</ul>
<p>各个工作者线程创建临时顺序的path后，由于具有 <strong><em>顺序</em></strong><br />
性，Zookeeper会按照它们创建的顺序在path后追加带有从1开始递增的编号。各个工作者创建完成后会得到各自的编号，然后它们作一个顺序判断，谁是最小的谁就会获得任务的执行机会并成为active工作者，而其他抢占失败的将默认切换到standby模式，这些抢占失败的工作者线程会注册成为它们抢占task的<br />
<strong>子节点变更</strong> watcher。这时 <strong><em>临时</em></strong><br />
属性就派上用场了，当处于active模式的工作者线程丢失会话之后，这些standby将会收到通知，而这时它们会再次去判断自己的编号是不是最小的，如果是那么就可以接替之前的工作者线程成为active的了。这时如果有新加入的工作者线程也会触发变更通知，但这并不会影响正常的逻辑。</p>
<p>当然这里还存在一些问题有待完善：</p>
<ul>
<li>active线程因为网络延迟出现短时会话丢失的问题，可能会导致Zookeeper错误的判断</li>
<li>子节点频繁变更可能会产生广播风暴</li>
</ul>
<h3>动态执行新任务</h3>
<p>每个任务组都会有一个watcher来监控是否有新的任务被创建（比如一种新的日志类型被提交）。如果有新任务则会在其所属的线程池中新建新的工作者来执行新任务。目前暂时这个watcher默认只关注新增任务，而针对任务被移除或者任务的元数据变更，watcher暂时还没有相应的响应机制。这也是后续需要考虑和完善的部分。</p>
<h3>后台服务配置模板化</h3>
<p>这种机制之前已经分别应用于<code>日志采集</code>、<code>日志解析</code>模块了，在这里也是为了简化后台服务启动时配置的问题。</p>
<h2>总结</h2>
<p>综上，整个设计的Zookeeper 拓扑图大致如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvN3hrYWF6LmNvbTEuejAuZ2xiLmNsb3VkZG4uY29tL2xpbmstbG9nLXN5c3RlbS1jb21wb25lbnQtd2l0aC16b29rZWVwZXJfbG9nc3lzdGVtLXpvb2tlZXBlci1kZXNpZ24ucG5n.jpg"></p>
<p>从上面的分析可以看到，我们最大程度地将各种可变的参数配置到Zookeeper中，使其成为串联起整个分布式系统的配置中心，而我们的管控台某种意义上退化成了“配置系统”——将配置界面化、持久化。同时，我们也利用了Zookeeper的实时事件Push机制，来进行分布式协调。</p>
<p>原文发布时间为：2015-12-26</p>
<p>本文作者：vinoYang</p>
<p>本文来自合作伙伴<a href="http://blog.csdn.net/yanghua_kobe/article/details/50410013" rel="external nofollow noreferrer">CSDN博客</a>，了解相关信息可以关注CSDN博客。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:25:15</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/path/" title="path">path</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/schema/" title="schema">schema</a>, <a href="https://www.iamivan.net/tag/elasticsearch/" title="Elasticsearch">Elasticsearch</a>, <a href="https://www.iamivan.net/tag/zookeeper/" title="zookeeper">zookeeper</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>日志系统之基于Zookeeper的分布式协同设计的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPkN48M.html" rel="bookmark">基于zookeeper的分布式并发锁实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于zookeeper的分布式并发锁实践 http://www.365yg.com/item/6421663785764782593/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12r83p.html" rel="bookmark">基于Web的PDM协同设计的设计与研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PDM(Product Data Management即产品数据管理)是在上个世纪80年代,为了方便制造企业大量的工程图纸和技术文档的管理而逐渐产生和发展起来的.传统的PDM以管理产品数据为核心,其主要功能是实现企业数据资料的管理.但是随着计算机技术的发展及其在制造企业应用领域的扩大,尤其是近几年来个性化.多元化的消费需求使得市场快速多变,企业之间的竞争更加激烈,这就要求在产品设计的过程中要同时从专业的角度和用户的角度来考虑产品的质量.功能.装配.设计.工艺参数.使用性能和寿命.而产品设计的开发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYj7mVp.html" rel="bookmark">基于Zookeeper的分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章只需要你10分钟的时间. 实现分布式锁目前有三种流行方案,分别为基于数据库.Redis.Zookeeper的方案,其中前两种方案网络上有很多资料可以参考,本文不做展开.我们来看下使用Zookeeper如何实现分布式锁. 什么是Zookeeper? Zookeeper(业界简称zk)是一种提供配置管理.分布式协同以及命名的中心化服务,这些提供的功能都是分布式系统中非常底层且必不可少的基本功能,但是如果自己实现这些功能而且要达到高吞吐.低延迟同时还要保持一致性和可用性,实际上非常困难.因此z			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGNXVp.html" rel="bookmark">基于zookeeper的分布式lock实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景  继续上一篇文章:http://agapple.iteye.com/blog/1183972 ,项目中需要对分布式任务进行调度,那对应的分布式lock实现在所难免.    这一周,在基于BooleanMutex的基础上,实现了zookeeper的分布式锁,用于控制多进程+多线程的lock控制   算法 可以预先看一下zookeeper的官方文档:    http://zookeeper.apache.org/doc/trunk/recipes.html lock操作过程: 首先为一个loc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW29Enb.html" rel="bookmark">基于ZooKeeper的分布式锁和队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在分布式系统中,往往需要一些分布式同步原语来做一些协同工作,上一篇文章介绍了Zookeeper的基本原理,本文介绍下基于Zookeeper的Lock和Queue的实现,主要代码都来自Zookeeper的官方recipe. 锁(Lock) 完全分布式锁是全局同步的,这意味着在任何时刻没有两个客户端会同时认为它们都拥有相同的锁,使用 Zookeeper 可以实现分布式锁,需要首先定义一个锁节点(lock root node). 需要获得锁的客户端按照以下步骤来获取锁: 保证锁节点(lock root			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0nqa6z.html" rel="bookmark">基于ZooKeeper实现分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ZooKeeper 保证了数据的强一致性,  zk集群中任意节点(一个zkServer)上的相同znode下的数据一定是相同的.使用zookeeper可以非常简单的实现分布式锁, 其基本逻辑如下: 客户端调用create()方法创建名为&quot;locknode/lock&quot;的节点,需要注意的是,这里节点的创建类型需要设置为EPHEMERAL_SEQUENTIAL. 客户端调用getChildren(&quot;lock&quot;)方法来获取所有已经创建的lock节点的子节点,同时在这个节点上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjd45p.html" rel="bookmark">日志系统之定时任务执行引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 最近这段时间在强化日志系统自身的稳定性和可靠性,一个稳定可靠的系统离不开监控,我们这里谈及的监控除了服务是否存活还有这些组件的核心metrics采集与抓取,为此我们将这些任务做成了定时任务来执行.由于大致的思路以及设计已经成型,所以今天来分享一下日志系统在定时任务这块的选型与设计. 组件运行时监控 从我之前分享的文章中不难看出我们日志系统的各个组件的选型: 采集agent : Flume-NG 消息系统 : Kafka 实时流处理 : Storm 分布式搜索/日志存储(暂时) : Elas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b22g9rb.html" rel="bookmark">基于Redis的分布式锁真的安全吗？（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自从我写完这个话题的上半部分之后,就感觉头脑中出现了许多细小的声音,久久挥之不去.它们就像是在为了一些鸡毛蒜皮的小事而相互争吵个不停.的确,有关分布式的话题就是这样,琐碎异常,而且每个人说的话听起来似乎都有道理.   今天,我们就继续探讨这个话题的后半部分.本文中,我们将从Antirez反驳Martin Kleppmann的观点开始讲起,然后会涉及到Hacker News上出现的一些讨论内容,接下来我们还会讨论到基于Zookeeper和Chubby的分布式锁是怎样的,并和Redlock进行一些对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8jAW4b.html" rel="bookmark">如何使用线程局部存储实现多线程下的日志系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 通常来说,在应用程序中需要日志来记录程序运行的状态,以便后期问题的跟踪定位.在日志系统的设计中,通常会有一个总的日志系统来统一协调这些日志的设置如位置.输出级别和内容等.在多线程编程中,当每个线程都需要输出日志时,因为要考虑线程间的同步,日志系统的设计更加复杂. 在单线程应用程序中,通常使用一个日志单例向某个文件输出应用运行过程中的重要日志信息,但是在多线程环境中,这样做显然不好,因为各个线程打印出的日志会错综复杂从而使得日志文件不容易阅读和跟踪.比较好的办法是主线程记录自己的日志,各个子			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5d6WM.html" rel="bookmark" class="title">实战讲解竞价创意的编写技巧</a>
					<div>
						创意撰写通用技巧 一条吸引人的创意,意味着更多人点击. 一条针对性的创意,意味着点击更精确. So...... 一条好的创意,会提高你在市场的竞争力! 创意的撰写技巧无非以下几种: 一.通配: 1.标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaLKnM.html" rel="bookmark" class="title">Photoshop快速修正灰蒙蒙的外景风景照片</a>
					<div>
						Photoshop快速修正灰蒙蒙的外景风景照片    先来张最终效果,拍摄于青海海北藏族自治州门源县.应该每个人都希望自己的照片看起来是这样通透,而不是灰蒙蒙的雾霾感吧?通透是什么?在摄影中是画面色彩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWoxBb.html" rel="bookmark" class="title">Linux系统常用命令</a>
					<div>
						  1 日期时间 1 通过date查看当前系统的时间 date 2 格式化显示时间 date +%Y--%m--%d,中间的连接符号可以是任意的 3 设置系统的时间 sudo date -s &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdBv5M.html" rel="bookmark" class="title">刀片服务器没落吸引力原因</a>
					<div>
						  最初,刀片服务器被认为是一种易于管理.压缩服务器体积.减少数据中心占用空间的有效方式.这种高效和便于管理特性使得刀片服务器成为现代数据中心的支柱,但是这种情况正在发生改变. 服务器制造商在不断地发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7nQVM.html" rel="bookmark" class="title">2345王牌浏览器怎么更换皮肤</a>
					<div>
						  首先,在菜单栏&quot;工具&quot;中选择&quot;换肤&quot;选项,打开&quot;皮肤中心&quot;. 图1 在皮肤中心中找到你想要的皮肤,点击&quot;使用此皮肤&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72WEAp.html" rel="bookmark" class="title">怎么把Word的内容以图片格式插入到Excel2010中&quest;</a>
					<div>
						  1.首先启动一篇原始的Word文件,选中需要以图片形式插入Excel中的某部分内容,按住&quot;Ctrl+C&quot;将其复制; 2.接下来启动Excel软件,单击&quot;打开&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42l9qM.html" rel="bookmark" class="title">关于错误页问题，在线坐等解决</a>
					<div>
						问题描述 网站报错误:您系统配置错误,请检查,不是所有页面都报错误代码,就是直接打开主页报,可以正常进入后台,各位能给与指导吗?错误页主页代码错误页代码WEB配置页代码WEB配置页代码WEB配置页代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZE2K6p.html" rel="bookmark" class="title">传字符串调用方法</a>
					<div>
						    [[targetCallBack objectForKey:@&quot;delegate&quot;] performSelector:NSSelectorFromString([targe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2Kxjb.html" rel="bookmark" class="title">Unicode与JavaScript详解</a>
					<div>
						上个月,我做了一次分享,详细介绍了Unicode字符集,以及JavaScript语言对它的支持.下面就是这次分享的讲稿. 一.Unicode是什么? Unicode源于一个很简单的想法:将全世界所有的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoNxOb.html" rel="bookmark" class="title">plsql developer 的注册码</a>
					<div>
						Serial Number:115139568Product Number:keqtkf6mb5z5kww7wkl4u3m84emzk6644mgj4gt2 Password:xs374ca					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2Emjb.html" rel="bookmark" class="title">java 经纬度计算 距离-java 经纬度计算距离 经纬和距离切换</a>
					<div>
						问题描述 java 经纬度计算距离 经纬和距离切换 怎么根据一个点的经纬度查询 以这个点为中心距离为200米以内的在业务系统中做过表示的建筑. 比如 经纬度分别为:113.2759952545166  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ4PVz.html" rel="bookmark" class="title">android报错-android开发报错log信息如下，小弟新手，求问是什么错误，错在哪，如何解决</a>
					<div>
						问题描述 android开发报错log信息如下,小弟新手,求问是什么错误,错在哪,如何解决 02-21 20:41:34.969: W/dalvikvm(20654): threadid=11: th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AAw4z.html" rel="bookmark" class="title">button-Button onClick事件不能运行</a>
					<div>
						问题描述 Button onClick事件不能运行 我创建一个viewPager,在每一个页面上有三个布局.在第二个页面上我想处理按钮事件,当点击按钮时背景颜色会变.但是现在我的代码不能运行.去掉bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm6GNb.html" rel="bookmark" class="title">Java眼中的XML－－文件读取－－2 应用SAX方式解析XML</a>
					<div>
						1.获取一个SAXParserFactory的实例.2.通过factory获取SAXParser实例. 3.新建一个包和继承自DefaultHandler的类. 因为SAX遍历方式,比如便利一个节点& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDRvaz.html" rel="bookmark" class="title">关于weblogic集群配置的问题&comma;各位高手过来帮忙看下啊&excl;&excl;</a>
					<div>
						问题描述 D:beauser_projectsdomainscamax&gt;startManagedWebLogic.cmdnodeAhttp://10.201.3.164:8084D:beause ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0rkKM.html" rel="bookmark" class="title">GitLab 致开源项目维护者的一封信</a>
					<div>
						前几日,GitHub 上一些流行的开源项目维护者联合签署了一篇名为&quot;亲爱的,GitHub&quot;的公开信,表达了对 GitHub 某些行为的不满之情. 接下来,GitLab 官方也发出了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2R71vb.html" rel="bookmark" class="title">Spark连续重大更新 热度急增</a>
					<div>
						文章讲的是Spark连续重大更新 热度急增,由于移动互联网数据量庞大且类型多样的特性,分布式计算在这一领域极受欢迎.Hadoop无疑是大数据开源环境下的王者,而本文的主角Spark和Storm与其一起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm006b.html" rel="bookmark" class="title">asp&period;net mvc ajax跳转？</a>
					<div>
						问题描述 asp.net mvc ajax跳转? 控制器里面有一个Get action ,一个Post action,如下 /// /// 手提電話驗證頁面 /// /// [AuthorizeFil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60ojXz.html" rel="bookmark" class="title">想clone一个网站  大概估算得多少钱啊</a>
					<div>
						问题描述 就是商家加盟平台(增/删/改/查)消费者平台(增/删/改/查)在附加一个开源的BBS/BLOG之类的就行了那位高手能介绍一下大概需要多少钱啊ASP.NET2.0+SQLServer2005有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Nar9p.html" rel="bookmark" class="title">PHP中的事务使用实例&lowbar;php实例</a>
					<div>
						&lt;?php //数据库连接 $conn = mysql_connect('localhost', 'root', ''); mysql_select_db('test', $conn); mys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N4Rlb.html" rel="bookmark" class="title">Socket通信中断检测问题</a>
					<div>
						问题描述 WaitData()方法服务器端是一个线程方法,每一个连接上来的用户都会开一个线程来跟它通信,问题是当有一用户由于网络中断了,服务器端提供的该线程就死在那里等待接收,根本没有检测到用户端已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAKxDp.html" rel="bookmark" class="title">Linux Shell脚本查看NUMA信息&lowbar;linux shell</a>
					<div>
						Nova在NFV场景下会提供NUMA相关高级特性,这里提供一个脚本查看计算节点的NUMA相关信息. #!/bin/bash function get_nr_processor() { grep '^p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPR1Ap.html" rel="bookmark" class="title">Android打开WIFI或者移动网络的代码实现</a>
					<div>
						MainActivity如下: package wy.testnetwork; import java.lang.reflect.Field; import java.lang.reflect.Inv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqq1Vp.html" rel="bookmark" class="title">jquery 多行文本框&lpar;textarea&rpar;高度变化&lowbar;jquery</a>
					<div>
						复制代码 代码如下: $(function(){     var $comment = $('#comment');  //获取评论框      $('.bigger').click(function ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdXQaz.html" rel="bookmark" class="title">《中国人工智能学会通讯》&mdash;&mdash;6&period;17 总结与展望</a>
					<div>
						6.17 总结与展望 知识图谱是知识工程的一个分支,以知识工程中语义网络作为理论基础,并且结合了机器学习.自然语言处理以及知识表示和推理的最新成果,在大数据的推动下受到了业界和学术界的广泛关注.知识图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXxeKz.html" rel="bookmark" class="title">php filter&lowbar;has&lowbar;var 判断变量是否存在函数</a>
					<div>
						定义和用法 该filter_has_var ( )函数检查,如果一个变量指定输入类型存在. 在返回TRUE或FALSE成功的失败. 语法 filter_has_var(type, variable)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBV3Wb.html" rel="bookmark" class="title">电子书出版平台Graphicly再获100万美元融资</a>
					<div>
						电子书出版平台 Graphicly 的前身是动漫出版平台,依 CEO 兼联合创始人 Micah Baldwin 的设想,他们原计划成为动漫领域的 iTunes,为动漫作者自由出售电子版动漫作品提供平台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Y6xLb.html" rel="bookmark" class="title">Check Point发布2017年网络安全预测</a>
					<div>
						2016年又是各行业.各种大小型企业再次遭受数据泄露的一年,即使相关机构适时发出了预警,而事实一再证明,在复杂的网络攻击面前,没有人可以免受攻击. 根据Identity Theft Resource  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3YQ33p.html" rel="bookmark" class="title">关于servelt跳转页面的问题</a>
					<div>
						问题描述 我写了一个曾删改查的servlet代码如下packagecom.qun520;importjava.io.IOException;importjava.sql.SQLException;im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd3YVM.html" rel="bookmark" class="title">javascript 日历提醒系统&lpar; 兼容所有浏览器 &rpar;&lowbar;时间日期</a>
					<div>
						功能介绍: 1.正常的日历功能. 2.等等等 3.接收 数组 例如: 复制代码 代码如下: new Calendar(&quot;id&quot;).show( { &quot;20091120&qu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
